----------------------------------------
-- Group Calendar 5 Copyright 2009, 2010 John Stephen, wobbleworks.com
-- All rights reserved, unauthorized redistribution is prohibited
----------------------------------------

----------------------------------------
GroupCalendar.UI._SettingsView = {}
----------------------------------------

function GroupCalendar.UI._SettingsView:New(pParent)
	return CreateFrame("Frame", nil, pParent)
end

function GroupCalendar.UI._SettingsView:Construct(pParent)
	self.Title = self:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	self.Title:SetPoint("TOP", self, "TOP", 17, -7)
	self.Title:SetText(GroupCalendar.cSettingsTitle)
	
	self.ThemeMenu = GroupCalendar:New(GroupCalendar.UIElementsLib._DropDownMenu, self, function (...) self:ThemeMenuFunc(...) end, 130)
	self.ThemeMenu:SetPoint("TOPLEFT", self, "TOPLEFT", 100, -55)
	self.ThemeMenu:SetTitle(GroupCalendar.cThemeLabel)
	function self.ThemeMenu.ItemClicked(pMenu, pItemID)
		GroupCalendar.Data.ThemeID = pItemID
		pMenu:SetSelectedValue(GroupCalendar.Data.ThemeID)
		GroupCalendar.UI.Window.MonthView:SetThemeID(GroupCalendar.Data.ThemeID)
	end
	
	self.TwentyFourHourTime = GroupCalendar:New(GroupCalendar.UIElementsLib._CheckButton, self, GroupCalendar.cTwentyFourHourTime)
	self.TwentyFourHourTime:SetPoint("TOPLEFT", self.ThemeMenu, "BOTTOMLEFT", 0, -30)
	self.TwentyFourHourTime:SetScript("OnClick", function (pCheckButton)
		GroupCalendar.Data.TwentyFourHourTime = pCheckButton:GetChecked() ~= nil
		SetCVar("timeMgrUseMilitaryTime", GroupCalendar.Data.TwentyFourHourTime and 1 or 0)
		self.TwentyFourHourTime:SetChecked(GetCVarBool("timeMgrUseMilitaryTime"))
	end)
	
	self.RecordTradeskills = GroupCalendar:New(GroupCalendar.UIElementsLib._CheckButton, self, GroupCalendar.cRecordTradeskills)
	self.RecordTradeskills:SetPoint("TOPLEFT", self.TwentyFourHourTime, "BOTTOMLEFT", 0, -15)
	self.RecordTradeskills:SetScript("OnClick", function (pCheckButton)
		GroupCalendar.Data.Prefs.DisableTradeskills = pCheckButton:GetChecked() == nil
		self.RecordTradeskills:SetChecked(not GroupCalendar.Data.Prefs.DisableTradeskills)
	end)
	
	self.AnnounceEvents = GroupCalendar:New(GroupCalendar.UIElementsLib._CheckButton, self, GroupCalendar.cAnnounceEvents)
	self.AnnounceEvents:SetPoint("TOPLEFT", self.RecordTradeskills, "BOTTOMLEFT", 0, -30)
	self.AnnounceEvents:SetScript("OnClick", function (pCheckButton)
		GroupCalendar.Data.Prefs.DisableEventReminders = pCheckButton:GetChecked() == nil
		GroupCalendar.Reminders:CalculateReminders()
		self.AnnounceEvents:SetChecked(not GroupCalendar.Data.Prefs.DisableEventReminders)
	end)
	
	self.AnnounceTradeskills = GroupCalendar:New(GroupCalendar.UIElementsLib._CheckButton, self, GroupCalendar.cAnnounceTradeskills)
	self.AnnounceTradeskills:SetPoint("TOPLEFT", self.AnnounceEvents, "BOTTOMLEFT", 0, -15)
	self.AnnounceTradeskills:SetScript("OnClick", function (pCheckButton)
		GroupCalendar.Data.Prefs.DisableTradeskillReminders = pCheckButton:GetChecked() == nil
		GroupCalendar.Reminders:CalculateReminders()
		self.AnnounceTradeskills:SetChecked(not GroupCalendar.Data.Prefs.DisableTradeskillReminders)
	end)
	
	self.AnnounceBirthdays = GroupCalendar:New(GroupCalendar.UIElementsLib._CheckButton, self, GroupCalendar.cAnnounceBirthdays)
	self.AnnounceBirthdays:SetPoint("TOPLEFT", self.AnnounceTradeskills, "BOTTOMLEFT", 0, -15)
	self.AnnounceBirthdays:SetScript("OnClick", function (pCheckButton)
		GroupCalendar.Data.Prefs.DisableBirthdayReminders = pCheckButton:GetChecked() == nil
		GroupCalendar.Reminders:CalculateReminders()
		self.AnnounceBirthdays:SetChecked(not GroupCalendar.Data.Prefs.DisableBirthdayReminders)
	end)
	
	self.RememberInvites = GroupCalendar:New(GroupCalendar.UIElementsLib._CheckButton, self, GroupCalendar.cRememberInvites)
	self.RememberInvites:SetPoint("TOPLEFT", self.AnnounceBirthdays, "BOTTOMLEFT", 0, -15)
	self.RememberInvites:SetScript("OnClick", function (pCheckButton)
		GroupCalendar.Data.Prefs.DisableInviteMemory = pCheckButton:GetChecked() == nil
		self.RememberInvites:SetChecked(not GroupCalendar.Data.Prefs.DisableInviteMemory)
	end)
	
	self:SetScript("OnShow", self.OnShow)
end

function GroupCalendar.UI._SettingsView:OnShow()
	self.ThemeMenu:SetSelectedValue(GroupCalendar.Data.ThemeID or "PARCHMENT")
	self.TwentyFourHourTime:SetChecked(GetCVarBool("timeMgrUseMilitaryTime"))
	self.AnnounceBirthdays:SetChecked(not GroupCalendar.Data.Prefs.DisableBirthdayReminders)
	self.AnnounceEvents:SetChecked(not GroupCalendar.Data.Prefs.DisableEventReminders)
	self.AnnounceTradeskills:SetChecked(not GroupCalendar.Data.Prefs.DisableTradeskillReminders)
	self.RecordTradeskills:SetChecked(not GroupCalendar.Data.Prefs.DisableTradeskills)
	self.RememberInvites:SetChecked(not GroupCalendar.Data.Prefs.DisableInviteMemory)
end

function GroupCalendar.UI._SettingsView:ThemeMenuFunc(pMenu, pMenuID)
	pMenu:AddNormalItem(GroupCalendar.cParchmentThemeName, "PARCHMENT", nil, not GroupCalendar.Data.ThemeID or GroupCalendar.Data.ThemeID == "PARCHMENT")
	pMenu:AddNormalItem(GroupCalendar.cSeasonalThemeName, "SEASONAL", nil, GroupCalendar.Data.ThemeID == "SEASONAL")
end
